<?php
require_once(dirname(__FILE__) . '/config/config.php');
require_once(dirname(__FILE__) . '/plugins/microsoft_integrations/library/microsoft_graph/microsoft_graph.php');

$log_file = dirname(__FILE__)."/cache/microsoft.log";

function _save_ms_access_token($user_id, $access_token) {	
	$link =  @mysqli_connect(DB_HOST, DB_USER, DB_PASS, DB_NAME);
	
	$serialized_token = base64_encode(serialize($access_token));
	
	$sql = "
		INSERT INTO ".TABLE_PREFIX."contact_config_option_values (`option_id`,`contact_id`,`value`) VALUES
		((SELECT id FROM ".TABLE_PREFIX."contact_config_options WHERE `name`='ms_access_token'), '$user_id', '$serialized_token')
		ON DUPLICATE KEY UPDATE `value`='$serialized_token'
	";
	
	mysqli_query($link, $sql);
	
}

function _get_ms_config_from_database($log_file) {
	$link = @mysqli_connect(DB_HOST, DB_USER, DB_PASS, DB_NAME);

  if (!$link) {
    $error_message = 'mysqli_connect error: ' . mysqli_connect_error();
    file_put_contents($log_file, $error_message, FILE_APPEND);
    throw new Exception($error_message);
  }

  $config = array();
  
  $sql = "
    SELECT
      `name`, `value`
    FROM
      " . TABLE_PREFIX . "config_options
    WHERE
      category_name = 'microsoft_integrations';
  ";
  $result = mysqli_query($link, $sql);

	if ($result) {
		while ($row = mysqli_fetch_array($result)) {
      switch ($row['name']) {
        case 'ms_client_id':
          $config['clientId'] = $row['value'];
          break;
        case 'ms_client_secret_value':
          $config['clientSecret'] = $row['value'];
          break;
        case 'ms_redirect_uri_suffix':
          $config['redirectUri'] = ROOT_URL . "/" . $row['value'];
          break;
        case 'ms_url_authorize':
          $config['urlAuthorize'] = $row['value'];
          break;
        case 'ms_url_access_token':
          $config['urlAccessToken'] = $row['value'];
          break;
        case 'ms_url_resource_owner_details':
          $config['urlResourceOwnerDetails'] = $row['value'];
          break;
        case 'ms_scopes':
          $config['scopes'] = $row['value'];
          break;                                 
      }
		}
	} else {
    $error_message = 'mysqli_query no result when fetching microsoft integration configuration';
    file_put_contents($log_file, $error_message, FILE_APPEND);
    throw new Exception($error_message);
  }
	
	return $config;
}

function callback($log_file){
	$parseUrl = null;
	parse_str($_SERVER['QUERY_STRING'], $parseUrl);
	
	file_put_contents($log_file, print_r($parseUrl, true), FILE_APPEND);
	
	// Authorization code should be in the "code" query param
	$authCode = $parseUrl['code'];
	
	if (isset($authCode)) {
    $oauthOptions = _get_ms_config_from_database($log_file);
    
    // Uncomment to debug configuration
    // file_put_contents($log_file, "MS configuration: " . print_r($oauthOptions, true), FILE_APPEND);

		$oauthClient = new \League\OAuth2\Client\Provider\GenericProvider($oauthOptions);
		
		try {
			// Make the token request
			$accessToken = $oauthClient->getAccessToken('authorization_code', [
					'code' => $authCode
			]);
			
			$tmp_user_id_file = dirname(__FILE__)."/tmp/user_id_to_connect_to_ms";
			$user_id = file_get_contents($tmp_user_id_file);
			@unlink($tmp_user_id_file);
			
			_save_ms_access_token($user_id, $accessToken);
			
			return;
			
		} catch (League\OAuth2\Client\Provider\Exception\IdentityProviderException $e) {
			file_put_contents($log_file, "Error when trying to get access token" . print_r($e, true), FILE_APPEND);
			return;
		}
	}
	
	file_put_contents($log_file, 'MS code not received', FILE_APPEND);
	return;
}

callback($log_file);
