<?php
require_once(dirname(__FILE__) . '/config/config.php');
require_once(dirname(__FILE__) . '/plugins/microsoft_integrations/library/microsoft_graph/microsoft_graph.php');
//use Illuminate\Http\Request;

function _save_ms_mail_account_access_token($account_id, $access_token) {
	
	include_once dirname(__FILE__) . '/config/config.php';
	
	$link =  @mysqli_connect(DB_HOST, DB_USER, DB_PASS, DB_NAME);
	$serialized_token = base64_encode(serialize($access_token));

	if($account_id) {
		$sql = "
			UPDATE ".TABLE_PREFIX."mail_accounts SET oauth2_access_token='$serialized_token', oauth2_provider='microsoft', uses_oauth2=1
			WHERE id = '$account_id';
		";
		mysqli_query($link, $sql);
	}

	// if we are adding a new account, it doesn't exist in the database so we store the token temporary in the session var
	$_SESSION['oauth2_access_token'] = $serialized_token;
	$_SESSION['oauth2_provider'] = 'microsoft';
	$_SESSION['uses_oauth2'] = 1;
	
}

function _get_ms_mail_config_from_database($log_file) {
	$link = @mysqli_connect(DB_HOST, DB_USER, DB_PASS, DB_NAME);

	if (!$link) {
		$error_message = 'mysqli_connect error: ' . mysqli_connect_error();
		file_put_contents($log_file, $error_message, FILE_APPEND);
		throw new Exception($error_message);
	}

	$config = array();
	
	$sql = "
		SELECT
		`name`, `value`
		FROM
		" . TABLE_PREFIX . "config_options
		WHERE
		category_name = 'microsoft_mail_integrations';
	";
	$result = mysqli_query($link, $sql);

	if ($result) {
		while ($row = mysqli_fetch_array($result)) {
			switch ($row['name']) {
				case 'ms_mail_client_id':
					$config['clientId'] = $row['value'];
					break;
				case 'ms_mail_client_secret_value':
					$config['clientSecret'] = $row['value'];
					break;
				case 'ms_mail_redirect_uri_suffix':
					$config['redirectUri'] = ROOT_URL . "/" . $row['value'];
					break;
				case 'ms_mail_url_authorize':
					$config['urlAuthorize'] = $row['value'];
					break;
				case 'ms_mail_url_access_token':
					$config['urlAccessToken'] = $row['value'];
					break;
				case 'ms_mail_url_resource_owner_details':
					$config['urlResourceOwnerDetails'] = $row['value'];
					break;
				case 'ms_mail_scopes':
					$config['scopes'] = $row['value'];
					break;                                 
			}
		}
	} else {
		$error_message = 'mysqli_query no result when fetching microsoft mail integration configuration';
		file_put_contents($log_file, $error_message, FILE_APPEND);
		throw new Exception($error_message);
  	}
	
	return $config;
}

function callback(){ 
	$log_file = dirname(__FILE__)."/cache/microsoft.log";
	
	$parseUrl = null;
	parse_str($_SERVER['QUERY_STRING'], $parseUrl);
	
	file_put_contents($log_file, "MAIL CALLBACK\n", FILE_APPEND);
	file_put_contents($log_file, print_r($parseUrl, true), FILE_APPEND);
	
	
	// Authorization code should be in the "code" query param
	$authCode = $parseUrl['code'];
	
	if (isset($authCode)) {

		file_put_contents($log_file, "AUTH CODE = $authCode\n", FILE_APPEND);

		$config = _get_ms_mail_config_from_database($log_file);

		try {

			file_put_contents($log_file, "ACA 1\n", FILE_APPEND);
			$oauthClient = new \League\OAuth2\Client\Provider\GenericProvider($config);

		} catch (Exception $e) {
			file_put_contents($log_file, "ERROR IN PROVIDER\n" . print_r($e, true), FILE_APPEND);
			return;
		} 
		
		
		try {
			// Make the token request
			file_put_contents($log_file, "ACA 2\n", FILE_APPEND);
			$accessToken = $oauthClient->getAccessToken('authorization_code', [
					'code' => $authCode
			]);
	
			file_put_contents($log_file, "ACCESS TOKEN\n", FILE_APPEND);
			file_put_contents($log_file, print_r($accessToken, true), FILE_APPEND);
			
			$tmp_user_id_file = dirname(__FILE__)."/tmp/user_id_to_connect_to_ms";
			$user_id = file_get_contents($tmp_user_id_file);
			@unlink($tmp_user_id_file);
	
			file_put_contents($log_file, "ACCOUNT ID = $user_id\n", FILE_APPEND);
			
			_save_ms_mail_account_access_token($user_id, $accessToken);
			
			return;
			
		} catch (League\OAuth2\Client\Provider\Exception\IdentityProviderException $e) {
			file_put_contents($log_file, "Error when tried to get access token\n" . print_r($e, true), FILE_APPEND);
			return;
		} catch (Exception $e) {
			file_put_contents($log_file, "EXCEPTION\n" . print_r($e, true), FILE_APPEND);
			return;
		} catch (Error $e) {
			file_put_contents($log_file, "ERROR\n" . print_r($e, true), FILE_APPEND);
			return;
		}
	}
	
	file_put_contents($log_file, 'MS code not received', FILE_APPEND);
	return;
}

callback();
