<?php
chdir(dirname(__FILE__));
define("CONSOLE_MODE", true);
define('PUBLIC_FOLDER', 'public');
include "init.php";
@set_time_limit(0);
ini_set("memory_limit", "1G");
Env::useHelper('microsoft_functions_incoming', 'microsoft_integrations');

$http_body = file_get_contents('php://input');

$decoded_data = json_decode($http_body, true);

if ($decoded_data) {
	foreach ($decoded_data['value'] as $notification) {
		
		$action = $notification['changeType'];
		
		if ($notification['resourceData']['@odata.type'] == '#Microsoft.Graph.Event') {
			
			$ms_event_id = $notification['resourceData']['id'];
			
			process_incoming_data_change_event($ms_event_id, $action);
		}
	}
}


if (isset($_REQUEST["validationToken"])) { // when creating a subscription
	header("HTTP/1.1 200 OK");
	header("Content-type: text/plain");
	echo $_REQUEST["validationToken"];
	
} else {// when receiving a change notification
	header("HTTP/1.1 202 ACCEPTED");
	header("Content-type: text/plain");
}

/*
 * Array
    (
        [value] => Array
            (
                [0] => Array
                    (
                        [subscriptionId] => 1f0625a9-74e5-4f11-8092-86aa7e59cd3f
                        [subscriptionExpirationDateTime] => 2021-07-13T16:03:56-07:00
                        [changeType] => updated
                        [resource] => Users/db69d6fb2ce3ca63/Events/AQMkADAwATY0MDABLTg0ZmEtODZiZS0wMAItMDAKAEYAAAPthklNOBRJTo49FkrCMg8gBwD2o3KW6FTPSIyAYwv6Tw1zAAACAQ0AAAD2o3KW6FTPSIyAYwv6Tw1zAASXI-wdAAAA
                        [resourceData] => Array
                            (
                                [@odata.type] => #Microsoft.Graph.Event
                                [@odata.id] => Users/db69d6fb2ce3ca63/Events/AQMkADAwATY0MDABLTg0ZmEtODZiZS0wMAItMDAKAEYAAAPthklNOBRJTo49FkrCMg8gBwD2o3KW6FTPSIyAYwv6Tw1zAAACAQ0AAAD2o3KW6FTPSIyAYwv6Tw1zAASXI-wdAAAA
                                [@odata.etag] => W/"DwAAABYAAAD2o3KW6FTPSIyAYwv6Tw1zAASXLkpH"
                                [id] => AQMkADAwATY0MDABLTg0ZmEtODZiZS0wMAItMDAKAEYAAAPthklNOBRJTo49FkrCMg8gBwD2o3KW6FTPSIyAYwv6Tw1zAAACAQ0AAAD2o3KW6FTPSIyAYwv6Tw1zAASXI-wdAAAA
                            )
    
                        [clientState] => 
                        [tenantId] => 
                    )
    
            )
    
    )
 */


/*
// get request parameters
$external_token = trim(array_var($_REQUEST, 'token', ''));
$json_entities = $_REQUEST['entities'];

$valid_user = false;

if ($external_token != '') {
	
	// find token object
	$token_object = ContactExternalTokens::instance()->findByToken($external_token);
	if ($token_object instanceof ContactExternalToken) {
		
		// get the token's owner
		$user = Contacts::instance()->findById($token_object->getContactId());
		
		// check if user is a valid user
		if ($user instanceof Contact && !$user->getDisabled() && $user->getUserType() > 0) {
			$valid_user = true;
			
			try {
				
				// log user in
				CompanyWebsite::instance()->logUserIn($user);
				
				// decode entities string
				$entities = json_decode(base64_decode($json_entities), true);
				
				// call controller function to process the changes
				$ms_controller = new MicrosoftController();
				$ms_controller->process_qbo_data_changes($entities);
				
			} catch (Error $e) {
				Logger::log_r("MS WEBHOOK: Error processing entities:\n".$e->getMessage());
			} catch (Exception $e) {
				Logger::log_r("MS WEBHOOK: Error processing entities:\n".$e->getMessage());
			}
			
		}
	}
}

if (!$valid_user) {
	Logger::log_r("MS WEBHOOK: could not update entities because of invalid user.\n".print_r($_REQUEST,1));
}
*/